diff --git a/backup/util/dbops/backup_question_dbops.class.php b/backup/util/dbops/backup_question_dbops.class.php
index 67ff54f..516651e 100644
--- a/backup/util/dbops/backup_question_dbops.class.php
+++ b/backup/util/dbops/backup_question_dbops.class.php
@@ -42,31 +42,42 @@ abstract class backup_question_dbops extends backup_dbops {
 
         // First step, annotate all the categories for the given context (course/module)
         // i.e. the whole context questions bank
-        $DB->execute("INSERT INTO {backup_ids_temp} (backupid, itemname, itemid)
-                      SELECT ?, 'question_category', id
-                        FROM {question_categories}
-                       WHERE contextid = ?", array($backupid, $contextid));
+        $rs = $DB->get_recordset_sql("SELECT id FROM {question_categories} WHERE contextid = ?",
+                array($contextid));
+        $cache_qc = backup_muc_manager::get('question_category');
+        foreach($rs as $record) {
+            $cache_qc->set($record->id, 1);
+        }
+        $rs->close();
 
         // Now, based in the annotated questions, annotate all the categories they
         // belong to (whole context question banks too)
         // First, get all the contexts we are going to save their question bank (no matter
         // where they are in the contexts hierarchy, transversals... whatever)
+        $cache_q = backup_muc_manager::get('question');
+        $questions = $cache_q->get_store()->find_all();
+        if (empty($questions)) {
+            return;
+        }
+
+        list($sql, $params) = $DB->get_in_or_equal($questions);
+        $params = array_merge(array($contextid), $params);
         $contexts = $DB->get_fieldset_sql("SELECT DISTINCT qc2.contextid
-                                             FROM {question_categories} qc2
-                                             JOIN {question} q ON q.category = qc2.id
-                                             JOIN {backup_ids_temp} bi ON bi.itemid = q.id
-                                            WHERE bi.backupid = ?
-                                              AND bi.itemname = 'question'
-                                              AND qc2.contextid != ?", array($backupid, $contextid));
+                                                 FROM {question_categories} qc2
+                                                 JOIN {question} q on q.category = qc2.id
+                                                WHERE qc2.contextid != ?
+                                                  AND q.id $sql", $params);
+
         // And now, simply insert all the question categories (complete question bank)
         // for those contexts if we have found any
         if ($contexts) {
             list($contextssql, $contextparams) = $DB->get_in_or_equal($contexts);
-            $params = array_merge(array($backupid), $contextparams);
-            $DB->execute("INSERT INTO {backup_ids_temp} (backupid, itemname, itemid)
-                          SELECT ?, 'question_category', id
-                            FROM {question_categories}
-                           WHERE contextid $contextssql", $params);
+            $rs = $DB->get_fieldset_sql("SELECT id
+                                            FROM {question_categories}
+                                           WHERE contextid $contextssql", $contextparams);
+            foreach($rs as $record) {
+                $cache_qc->set($record, 1);
+            }
         }
     }
 
@@ -74,7 +85,7 @@ abstract class backup_question_dbops extends backup_dbops {
      * Delete all the annotated questions present in backup_ids_temp
      */
     public static function delete_temp_questions($backupid) {
-        global $DB;
-        $DB->delete_records('backup_ids_temp', array('backupid' => $backupid, 'itemname' => 'question'));
+        $cache = backup_muc_manager::get('question');
+        $cache->purge();
     }
 }
diff --git a/backup/util/dbops/backup_structure_dbops.class.php b/backup/util/dbops/backup_structure_dbops.class.php
index 4ceb221..ca492ac 100644
--- a/backup/util/dbops/backup_structure_dbops.class.php
+++ b/backup/util/dbops/backup_structure_dbops.class.php
@@ -34,13 +34,30 @@ abstract class backup_structure_dbops extends backup_dbops {
 
     public static function get_iterator($element, $params, $processor) {
         global $DB;
+
         // Check we are going to get_iterator for one backup_nested_element
         if (! $element instanceof backup_nested_element) {
             throw new base_element_struct_exception('backup_nested_element_expected');
         }
+
+        if ($params) {
+            $param_values = self::convert_params_to_values($params, $processor);
+        } else {
+            $param_values = array();
+        }
+
+        if ($element->procparams2) {
+            $param_values2 = self::convert_params_to_values($element->procparams2, $processor);
+        } else {
+            $param_values2 = array();
+        }
+
+        list($sql2, $params2) =  $element->get_source_sql_using_backup_ids($param_values2);
+
         // If var_array, table and sql are null, and element has no final elements it is one nested element without source
         // Just return one 1 element iterator without information
         if ($element->get_source_array() === null && $element->get_source_table() === null &&
+            $element->get_source_cache() === null && $sql2 === null &&
             $element->get_source_sql() === null && count($element->get_final_elements()) == 0) {
             return new backup_array_iterator(array(0 => null));
 
@@ -48,10 +65,16 @@ abstract class backup_structure_dbops extends backup_dbops {
             return new backup_array_iterator($element->get_source_array());
 
         } else if ($element->get_source_table() !== null) { // It's one table, return recordset iterator
-            return $DB->get_recordset($element->get_source_table(), self::convert_params_to_values($params, $processor), $element->get_source_table_sortby());
+            return $DB->get_recordset($element->get_source_table(), $param_values, $element->get_source_table_sortby());
 
         } else if ($element->get_source_sql() !== null) { // It's one sql, return recordset iterator
-            return $DB->get_recordset_sql($element->get_source_sql(), self::convert_params_to_values($params, $processor));
+            return $DB->get_recordset_sql($element->get_source_sql(), $param_values);
+
+        } else if (!is_null($sql2)) { // It's one sql, return recordset iterator but using backup ids cache
+            return $DB->get_recordset_sql($sql2, $params2);
+
+        } else if ($element->get_source_cache() !== null) { // Purely out of the cache
+            return new backup_array_iterator($element->get_source_cache());
 
         } else { // No sources, supress completely, using null iterator
             return new backup_null_iterator();
@@ -96,11 +119,9 @@ abstract class backup_structure_dbops extends backup_dbops {
         if ($itemid <= 0 || is_null($itemid)) {
             return;
         }
-        // TODO: Analyze if some static (and limited) cache by the 3 params could save us a bunch of record_exists() calls
-        // Note: Sure it will!
-        if (!$DB->record_exists('backup_ids_temp', array('backupid' => $backupid, 'itemname' => $itemname, 'itemid' => $itemid))) {
-            $DB->insert_record('backup_ids_temp', array('backupid' => $backupid, 'itemname' => $itemname, 'itemid' => $itemid));
-        }
+
+        $cache = backup_muc_manager::get('' . $itemname);
+        $cache->set($itemid, 1);
     }
 
     /**
@@ -158,20 +179,23 @@ abstract class backup_structure_dbops extends backup_dbops {
     public static function move_annotations_to_final($backupid, $itemname, \core\progress\base $progress) {
         global $DB;
         $progress->start_progress('move_annotations_to_final');
-        $rs = $DB->get_recordset('backup_ids_temp', array('backupid' => $backupid, 'itemname' => $itemname));
+        $cache = backup_muc_manager::get('' . $itemname);
+        $cache_content = $cache->get_store()->find_all();
+
+        $cache_final = backup_muc_manager::get('' . $itemname . 'final');
+        $cache_content_final = $cache_final->get_store()->find_all();
+
         $progress->progress();
-        foreach($rs as $annotation) {
+        foreach($cache_content as $annotation_id) {
+            $annotation = $cache->get($annotation_id);
             // If corresponding 'itemfinal' annotation does not exist, update 'item' to 'itemfinal'
-            if (! $DB->record_exists('backup_ids_temp', array('backupid' => $backupid,
-                                                              'itemname' => $itemname . 'final',
-                                                              'itemid' => $annotation->itemid))) {
-                $DB->set_field('backup_ids_temp', 'itemname', $itemname . 'final', array('id' => $annotation->id));
+            if (!isset($cache_content_final[$annotation_id])) {
+                $cache_final->set($annotation_id, $annotation);
             }
             $progress->progress();
         }
-        $rs->close();
         // All the remaining $itemname annotations can be safely deleted
-        $DB->delete_records('backup_ids_temp', array('backupid' => $backupid, 'itemname' => $itemname));
+        $cache->purge();
         $progress->end_progress();
     }
 
@@ -179,7 +203,8 @@ abstract class backup_structure_dbops extends backup_dbops {
      * Returns true/false if there are annotations for a given item
      */
     public static function annotations_exist($backupid, $itemname) {
-        global $DB;
-        return (bool)$DB->count_records('backup_ids_temp', array('backupid' => $backupid, 'itemname' => $itemname));
+        $cache = backup_muc_manager::get('' . $itemname);
+        $cache_content = $cache->get_store()->find_all();
+        return !empty($cache_content);
     }
 }
diff --git a/backup/util/dbops/restore_controller_dbops.class.php b/backup/util/dbops/restore_controller_dbops.class.php
index b68358e..5ac7cdb 100644
--- a/backup/util/dbops/restore_controller_dbops.class.php
+++ b/backup/util/dbops/restore_controller_dbops.class.php
@@ -103,28 +103,10 @@ abstract class restore_controller_dbops extends restore_dbops {
     }
 
     public static function create_restore_temp_tables($restoreid) {
-        global $CFG, $DB;
-        $dbman = $DB->get_manager(); // We are going to use database_manager services
-
-        if ($dbman->table_exists('backup_ids_temp')) { // Table exists, from restore prechecks
-            // TODO: Improve this by inserting/selecting some record to see there is restoreid match
-            // TODO: If not match, exception, table corresponds to another backup/restore operation
-            return true;
-        }
-        backup_controller_dbops::create_backup_ids_temp_table($restoreid);
-        backup_controller_dbops::create_backup_files_temp_table($restoreid);
         return false;
     }
 
     public static function drop_restore_temp_tables($backupid) {
-        global $DB;
-        $dbman = $DB->get_manager(); // We are going to use database_manager services
-
-        $targettablenames = array('backup_ids_temp', 'backup_files_temp');
-        foreach ($targettablenames as $targettablename) {
-            $table = new xmldb_table($targettablename);
-            $dbman->drop_table($table); // And drop it
-        }
         // Invalidate the backup_ids caches.
         restore_dbops::reset_backup_ids_cached();
     }
